Index: dll/win32/iphlpapi/ifenum_reactos.c
===================================================================
--- dll/win32/iphlpapi/ifenum_reactos.c	(revision 64264)
+++ dll/win32/iphlpapi/ifenum_reactos.c	(working copy)
@@ -81,8 +81,8 @@
 
     if(!status)
     {
-            WARN("IOCTL Failed\n");
-            return STATUS_UNSUCCESSFUL;
+        WARN("IOCTL Failed\n");
+        return STATUS_UNSUCCESSFUL;
     }
 
     TRACE("TdiGetMibForIfEntity() => {\n"
@@ -183,21 +183,17 @@
                     TDIEntityID ip_ent;
                     int j;
 
-		    status = getNthIpEntity( tcpFile, curInterf, &ip_ent );
-		    if( NT_SUCCESS(status) )
-			status = tdiGetIpAddrsForIpEntity
-			    ( tcpFile, &ip_ent, &addrs, &numAddrs );
-		    for( j = 0; j < numAddrs && NT_SUCCESS(status); j++ ) {
-			TRACE("ADDR %d: index %d (target %d)\n", j, addrs[j].iae_index, infoSetInt[curInterf].if_info.ent.if_index);
-			if( addrs[j].iae_index ==
-			    infoSetInt[curInterf].if_info.ent.if_index ) {
-			    memcpy( &infoSetInt[curInterf].ip_addr,
-				    &addrs[j],
-				    sizeof( addrs[j] ) );
-			    curInterf++;
-			    break;
-			}
-		    }
+                    status = getNthIpEntity( tcpFile, curInterf, &ip_ent );
+                    if( NT_SUCCESS(status) )
+                        status = tdiGetIpAddrsForIpEntity( tcpFile, &ip_ent, &addrs, &numAddrs );
+                    for( j = 0; j < numAddrs && NT_SUCCESS(status); j++ ) {
+                        TRACE("ADDR %d: index %d (target %d)\n", j, addrs[j].iae_index, infoSetInt[curInterf].if_info.ent.if_index);
+                        if( addrs[j].iae_index == infoSetInt[curInterf].if_info.ent.if_index ) {
+                            memcpy( &infoSetInt[curInterf].ip_addr, &addrs[j], sizeof( addrs[j] ) );
+                            curInterf++;
+                            break;
+                        }
+                    }
                 }
             }
         }
@@ -242,8 +238,8 @@
 
     for( i = 0; i < numEntities; i++ ) {
         if( isInterface( &entitySet[i] ) &&
-            (!onlyNonLoopback ||
-	     (onlyNonLoopback && !isLoopback( tcpFile, &entitySet[i] ))) )
+            ( !onlyNonLoopback ||
+            ( onlyNonLoopback && !isLoopback( tcpFile, &entitySet[i] ) ) ) )
             numInterfaces++;
     }
 
@@ -395,50 +391,49 @@
 }
 
 InterfaceIndexTable *getInterfaceIndexTableInt( BOOL nonLoopbackOnly ) {
-  DWORD numInterfaces, curInterface = 0;
-  int i;
-  IFInfo *ifInfo;
-  InterfaceIndexTable *ret = 0;
-  HANDLE tcpFile;
-  NTSTATUS status = openTcpFile( &tcpFile );
+    DWORD numInterfaces, curInterface = 0;
+    int i;
+    IFInfo *ifInfo;
+    InterfaceIndexTable *ret = 0;
+    HANDLE tcpFile;
+    NTSTATUS status = openTcpFile( &tcpFile );
 
-  if( NT_SUCCESS(status) ) {
-      status = getInterfaceInfoSet( tcpFile, &ifInfo, &numInterfaces );
+    if( NT_SUCCESS(status) ) {
+        status = getInterfaceInfoSet( tcpFile, &ifInfo, &numInterfaces );
 
-      TRACE("InterfaceInfoSet: %08x, %04x:%08x\n",
-	     status,
-	     ifInfo->entity_id.tei_entity,
-	     ifInfo->entity_id.tei_instance);
+        TRACE("InterfaceInfoSet: %08x, %04x:%08x\n",
+           status,
+           ifInfo->entity_id.tei_entity,
+           ifInfo->entity_id.tei_instance);
 
-      if( NT_SUCCESS(status) ) {
-          ret = (InterfaceIndexTable *)
-              calloc(1,
-                     sizeof(InterfaceIndexTable) +
-                     (numInterfaces - 1) * sizeof(DWORD));
+        if( NT_SUCCESS(status) ) {
+            ret = (InterfaceIndexTable *)
+            calloc(1,
+                   sizeof(InterfaceIndexTable) +
+                   (numInterfaces - 1) * sizeof(DWORD));
 
-          if (ret) {
-              ret->numAllocated = numInterfaces;
-	      TRACE("NumInterfaces = %d\n", numInterfaces);
+            if (ret) {
+                ret->numAllocated = numInterfaces;
+                TRACE("NumInterfaces = %d\n", numInterfaces);
 
-              for( i = 0; i < numInterfaces; i++ ) {
-		  TRACE("Examining interface %d\n", i);
-                  if( !nonLoopbackOnly ||
-                      !isLoopback( tcpFile, &ifInfo[i].entity_id ) ) {
-		      TRACE("Interface %d matches (%d)\n", i, curInterface);
-                      ret->indexes[curInterface++] =
-                          ifInfo[i].if_info.ent.if_index;
-                  }
-              }
+                for( i = 0; i < numInterfaces; i++ ) {
+                    TRACE("Examining interface %d\n", i);
+                    if( !nonLoopbackOnly ||
+                        !isLoopback( tcpFile, &ifInfo[i].entity_id ) ) {
+                        TRACE("Interface %d matches (%d)\n", i, curInterface);
+                        ret->indexes[curInterface++] = ifInfo[i].if_info.ent.if_index;
+                    }
+                }
 
-              ret->numIndexes = curInterface;
-          }
+                ret->numIndexes = curInterface;
+            }
 
-          tdiFreeThingSet( ifInfo );
-      }
-      closeTcpFile( tcpFile );
-  }
+            tdiFreeThingSet( ifInfo );
+        }
+        closeTcpFile( tcpFile );
+    }
 
-  return ret;
+    return ret;
 }
 
 InterfaceIndexTable *getInterfaceIndexTable(void) {
@@ -640,71 +635,73 @@
 NTSTATUS addIPAddress( IPAddr Address, IPMask Mask, DWORD IfIndex,
                        PULONG NteContext, PULONG NteInstance )
 {
-  HANDLE tcpFile;
-  NTSTATUS status = openTcpFile( &tcpFile );
-  IP_SET_DATA Data;
-  IO_STATUS_BLOCK Iosb;
+    HANDLE tcpFile;
+    NTSTATUS status = openTcpFile( &tcpFile );
+    IP_SET_DATA Data;
+    IO_STATUS_BLOCK Iosb;
 
-  TRACE("Called.\n");
+    TRACE("Called.\n");
 
-  if( !NT_SUCCESS(status) ) return status;
+    if( !NT_SUCCESS(status) )
+        return status;
 
-  Data.NteContext = IfIndex;
-  Data.NewAddress = Address;
-  Data.NewNetmask = Mask;
+    Data.NteContext = IfIndex;
+    Data.NewAddress = Address;
+    Data.NewNetmask = Mask;
 
-  status = NtDeviceIoControlFile( tcpFile,
-                                  NULL,
-                                  NULL,
-                                  NULL,
-                                  &Iosb,
-                                  IOCTL_SET_IP_ADDRESS,
-                                  &Data,
-                                  sizeof(Data),
-                                  &Data,
-                                  sizeof(Data) );
+    status = NtDeviceIoControlFile( tcpFile,
+                                    NULL,
+                                    NULL,
+                                    NULL,
+                                    &Iosb,
+                                    IOCTL_SET_IP_ADDRESS,
+                                    &Data,
+                                    sizeof(Data),
+                                    &Data,
+                                    sizeof(Data) );
 
-  closeTcpFile( tcpFile );
+    closeTcpFile( tcpFile );
 
-  if( NT_SUCCESS(status) ) {
-      *NteContext = Iosb.Information;
-      *NteInstance = Data.NewAddress;
-  }
+    if( NT_SUCCESS(status) ) {
+        *NteContext = Iosb.Information;
+        *NteInstance = Data.NewAddress;
+    }
 
-  if (!NT_SUCCESS(status)) {
-      ERR("addIPAddress for if %d returning 0x%lx\n", IfIndex, status);
-  }
+    if (!NT_SUCCESS(status)) {
+        ERR("addIPAddress for if %d returning 0x%lx\n", IfIndex, status);
+    }
 
-  return status;
+    return status;
 
 }
 
 NTSTATUS deleteIpAddress( ULONG NteContext )
 {
-  HANDLE tcpFile;
-  NTSTATUS status = openTcpFile( &tcpFile );
-  IO_STATUS_BLOCK Iosb;
+    HANDLE tcpFile;
+    NTSTATUS status = openTcpFile( &tcpFile );
+    IO_STATUS_BLOCK Iosb;
 
-  TRACE("Called.\n");
+    TRACE("Called.\n");
 
-  if( !NT_SUCCESS(status) ) return status;
+    if( !NT_SUCCESS(status) )
+        return status;
 
-  status = NtDeviceIoControlFile( tcpFile,
-                                  NULL,
-                                  NULL,
-                                  NULL,
-                                  &Iosb,
-                                  IOCTL_DELETE_IP_ADDRESS,
-                                  &NteContext,
-                                  sizeof(USHORT),
-                                  NULL,
-                                  0 );
+    status = NtDeviceIoControlFile( tcpFile,
+                                    NULL,
+                                    NULL,
+                                    NULL,
+                                    &Iosb,
+                                    IOCTL_DELETE_IP_ADDRESS,
+                                    &NteContext,
+                                    sizeof(USHORT),
+                                    NULL,
+                                    0 );
 
-  closeTcpFile( tcpFile );
+    closeTcpFile( tcpFile );
 
-  if (!NT_SUCCESS(status)) {
-      ERR("deleteIpAddress(%lu) returning 0x%lx\n", NteContext, status);
-  }
+    if (!NT_SUCCESS(status)) {
+        ERR("deleteIpAddress(%lu) returning 0x%lx\n", NteContext, status);
+    }
 
-  return status;
-}
+    return status;
+}
\ No newline at end of file