Index: base/applications/network/net/lang/ru-RU.rc
===================================================================
--- base/applications/network/net/lang/ru-RU.rc	(revision 0)
+++ base/applications/network/net/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,64 @@
+/* Russian translation by Kudratov Olimjon, 2014.09.25 */
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+STRINGTABLE
+BEGIN
+    IDS_ACCOUNTS_SYNTAX "Использование:\nNET ACCOUNTS [/FORCELOGOFF:{Минуты | NO}] [/MINPWLEN: Длина]\n\
+             [/MAXPWAGE:{Дни | UNLIMITED}] [/MINPWAGE:Дни]\n\
+             [/UNIQUEPW:Число] [/DOMAIN]\n"
+    IDS_ACCOUNTS_HELP "ACCOUNTS\n..."
+    IDS_COMPUTER_SYNTAX "Использование:\nNET COMPUTER ..."
+    IDS_COMPUTER_HELP "COMPUTER\n..."
+    IDS_CONFIG_SYNTAX "Использование:\nNET CONFIG ..."
+    IDS_CONFIG_HELP "CONFIG\n..."
+    IDS_CONTINUE_SYNTAX "Использование:\nNET CONTINUE <Имя службы>"
+    IDS_CONTINUE_HELP "CONTINUE\n..."
+    IDS_FILE_SYNTAX "Использование:\nNET FILE ..."
+    IDS_FILE_HELP "FILE\n..."
+    IDS_GROUP_SYNTAX "Использование:\nNET GROUP ..."
+    IDS_GROUP_HELP "GROUP\n..."
+    IDS_HELPMSG_SYNTAX "Использование:\nNET HELPMSG <Код ошибки>"
+    IDS_HELPMSG_HELP "HELPMSG\n..."
+    IDS_LOCALGROUP_SYNTAX "Использование:\nNET LOCALGROUP ..."
+    IDS_LOCALGROUP_HELP "LOCALGROUP\n..."
+    IDS_NAME_SYNTAX "Использование:\nNET NAME ..."
+    IDS_NAME_HELP "NAME\n..."
+    IDS_PRINT_SYNTAX  "Использование:\nNET PRINT ..."
+    IDS_PRINT_HELP "PRINT\n..."
+    IDS_PAUSE_SYNTAX "Использование:\nNET PAUSE <Имя службы>"
+    IDS_PAUSE_HELP "PAUSE\n..."
+    IDS_SEND_SYNTAX "Использование:\nNET SEND ..."
+    IDS_SEND_HELP "SEND\n..."
+    IDS_SESSION_SYNTAX "Использование:\nNET SESSION ..."
+    IDS_SESSION_HELP "SESSION\n..."
+    IDS_SHARE_SYNTAX "Использование:\nNET SHARE ..."
+    IDS_SHARE_HELP "SHARE\n..."
+    IDS_START_SYNTAX "Использование:\nNET START ..."
+    IDS_START_HELP "START\n..."
+    IDS_STATISTICS_SYNTAX "Использование:\nNET STATISTICS ..."
+    IDS_STATISTICS_HELP "STATISTICS\n..."
+    IDS_STOP_SYNTAX "Использование:\nNET STOP <Имя службы>"
+    IDS_STOP_HELP "STOP\n..."
+    IDS_TIME_SYNTAX "Использование:\nNET TIME ..."
+    IDS_TIME_HELP "TIME\n..."
+    IDS_USE_SYNTAX "Использование:\nNET USE ..."
+    IDS_USE_HELP "USE\n..."
+    IDS_USER_SYNTAX "Использование:\nNET USER ..."
+    IDS_USER_HELP "USER\n..."
+    IDS_VIEW_SYNTAX "Использование:\nNET VIEW ..."
+    IDS_VIEW_HELP "VIEW\n..."
+    IDS_HELP_SYNTAX "Использование:\nNET HELP <Команда>\n   - или -\nNET <Команда> /HELP\n\n\
+   Доступны следующие команды:\n\n\
+   NET ACCOUNTS             NET HELP                 NET SHARE\n\
+   NET COMPUTER             NET HELPMSG              NET START\n\
+   NET CONFIG               NET LOCALGROUP           NET STATISTICS\n\
+   NET CONFIG SERVER        NET NAME                 NET STOP\n\
+   NET CONFIG WORKSTATION   NET PAUSE                NET TIME\n\
+   NET CONTINUE             NET PRINT                NET USE\n\
+   NET FILE                 NET SEND                 NET USER\n\
+   NET GROUP                NET SESSION              NET VIEW\n\n\
+   ..."
+    IDS_NET_SYNTAX "Использование:\nNET [ ACCOUNTS | COMPUTER | CONFIG | CONTINUE | FILE | GROUP | HELP |\n\
+      HELPMSG | LOCALGROUP | NAME | PAUSE | PRINT | SEND | SESSION |\n\
+      SHARE | START | STATISTICS | STOP | TIME | USE | NET USER | VIEW ]\n"
+END
Index: base/applications/network/net/net.rc
===================================================================
--- base/applications/network/net/net.rc	(revision 64350)
+++ base/applications/network/net/net.rc	(working copy)
@@ -18,3 +18,6 @@
 #ifdef LANGUAGE_RO_RO
     #include "lang/ro-RO.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
Index: base/applications/network/wlanconf/lang/ru-RU.rc
===================================================================
--- base/applications/network/wlanconf/lang/ru-RU.rc	(revision 0)
+++ base/applications/network/wlanconf/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,38 @@
+/* Russian translation by Kudratov Olimjon, 2014.09.25 */
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+STRINGTABLE
+BEGIN
+    IDS_USAGE "\nНастройте WLAN адаптер.\n\n\
+WLANCONF [-c SSID [-w WEP] [-a]] [-d] [-s]\n\n\
+\t-c SSID\t\tПодключается к указанному SSID,\n\
+\t-w WEP\t\tЗадает WEP ключ для использования.\n\
+\t-a\t\tУказывает целевую сеть is ad-hoc\n\
+\t-d\t\tОтключается от текущей точки доступа.\n\
+\t-s\t\tСканирует и отображает список точек доступа\n\
+\t\t\tв области.\n\n\
+При отсутствии параметров отображает информацию о текущем WLAN соединении\n"
+    IDS_NO_NETWORK "Не найдено сетей в области\n"
+    IDS_NO_WLAN_ADAPTER "Не найден WLAN адаптер в системе\n"
+    IDS_SUCCESS "Операция завершена успешно.\n"
+    IDS_WLAN_DISCONNECT "\nWLAN отключен\n"
+    IDS_MSG_WEP_ENABLED "WEP включен: %s\n"
+    IDS_MSG_NETWORK_MODE "Режим сети: %s\n"
+    IDS_MSG_CURRENT_WIRELESS "\nТекущая информация конфигурации беспроводной сети:\n\n"
+    IDS_MSG_ENCRYPTED "Зашифровано: %s\n"
+    IDS_MSG_NETWORK_TYPE "Тип сети: %s\n"
+    IDS_MSG_RSSI "RSSI: %i dBm\n"
+    IDS_MSG_SUPPORT_RATE "Поддерживаемые скорости (Mbps): "
+    IDS_MSG_TRANSMISSION_POWER "Мощность передатчика: %d mW\n"
+    IDS_MSG_ANTENNA_COUNT "Число антенн: %d\n"
+    IDS_MSG_TRANSMIT_ANTENNA "Передающая антенна: %d\n"
+    IDS_MSG_TRANSMIT_ANTENNA_ANY "Передающая антенна: Любая\n"
+    IDS_MSG_RECEIVE_ANTENNA "Принимающая антенна: %d\n"
+    IDS_MSG_RECEIVE_ANTENNA_ANY "Принимающая антенна: Любая\n"
+    IDS_MSG_FRAGMENT_THRESHOLD "Порог фрагментации: %d байт\n"
+    IDS_MSG_RTS_THRESHOLD "Порог RTS: %d байт\n"
+    IDS_YES "Да"
+    IDS_NO "Нет"
+    IDS_ADHOC "Adhoc"
+    IDS_INFRASTRUCTURE "Инфраструктура"
+END
Index: base/applications/network/wlanconf/wlanconf.rc
===================================================================
--- base/applications/network/wlanconf/wlanconf.rc	(revision 64350)
+++ base/applications/network/wlanconf/wlanconf.rc	(working copy)
@@ -31,6 +31,9 @@
 #ifdef LANGUAGE_RO_RO
     #include "lang/ro-RO.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
 #ifdef LANGUAGE_SQ_AL
     #include "lang/sq-AL.rc"
 #endif
Index: dll/win32/hhctrl.ocx/lang/Ru.rc
===================================================================
--- dll/win32/hhctrl.ocx/lang/Ru.rc	(revision 64350)
+++ dll/win32/hhctrl.ocx/lang/Ru.rc	(working copy)
@@ -31,8 +31,8 @@
     IDS_SEARCH       "&Поиск"
     IDS_FAVORITES    "&Избранное"
 
-    IDS_HIDETABS     "Hide &Tabs"
-    IDS_SHOWTABS     "Show &Tabs"
+    IDS_HIDETABS     "&Скрыть вкладки"
+    IDS_SHOWTABS     "&Показать вкладки"
 END
 
 STRINGTABLE
@@ -54,12 +54,12 @@
     POPUP "" /* Options */
     {
         MENUITEM "", IDTB_EXPAND
-        MENUITEM "S&ync", IDTB_SYNC
-        MENUITEM "&Back", IDTB_BACK
-        MENUITEM "&Forward", IDTB_FORWARD
-        MENUITEM "&Home", IDTB_HOME
-        MENUITEM "&Stop", IDTB_STOP
-        MENUITEM "&Refresh", IDTB_REFRESH
-        MENUITEM "&Print...", IDTB_PRINT
+        MENUITEM "С&инхронизировать", IDTB_SYNC
+        MENUITEM "&Назад", IDTB_BACK
+        MENUITEM "&Вперед", IDTB_FORWARD
+        MENUITEM "&Домой", IDTB_HOME
+        MENUITEM "&Остановить", IDTB_STOP
+        MENUITEM "О&бновить", IDTB_REFRESH
+        MENUITEM "&Печать...", IDTB_PRINT
     }
 }
Index: subsystems/ntvdm/lang/ru-RU.rc
===================================================================
--- subsystems/ntvdm/lang/ru-RU.rc	(revision 0)
+++ subsystems/ntvdm/lang/ru-RU.rc	(working copy)
@@ -0,0 +1,14 @@
+LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+
+STRINGTABLE
+BEGIN
+    IDS_HIDE_MOUSE, "&Спрятать указатель мыши"
+    IDS_SHOW_MOUSE, "&Отобразить указатель мыши"
+    IDS_VDM_MENU  , "ReactOS &VDM"
+END
+
+STRINGTABLE
+BEGIN
+    IDS_VDM_DUMPMEM,    "Дамп &памяти"
+    IDS_VDM_QUIT   ,    "&Выйти из ReactOS VDM"
+END
Index: subsystems/ntvdm/ntvdm.rc
===================================================================
--- subsystems/ntvdm/ntvdm.rc	(revision 64350)
+++ subsystems/ntvdm/ntvdm.rc	(working copy)
@@ -40,3 +40,6 @@
 #ifdef LANGUAGE_RO_RO
     #include "lang/ro-RO.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif